import requests
import re
import base64
import zlib
import marshal
import time
from multiprocessing import Process
from urllib.parse import quote
from colorama import Fore, Style

def decrypt(code, layers):
    current = code
    for _ in range(layers):
        current = marshal.loads(zlib.decompress(base64.b85decode(current)))
    xor_encrypted = [b ^ 50 for b in current]
    return marshal.loads(bytes(xor_encrypted))

def share_worker(share_url, headers, data, share_num):
    try:
        response = requests.post(share_url, headers=headers, json=data)
        response.raise_for_status()
        if response.status_code == 200:
            print(Fore.YELLOW + f"分享第{share_num}次：" + Fore.GREEN + "分享成功" + Style.RESET_ALL)
        else:
            print(Fore.YELLOW + f"分享第{share_num}次：" + Fore.RED + f"分享失败，状态码: {response.status_code}" + Style.RESET_ALL)
    except requests.exceptions.RequestException as e:
        print(Fore.YELLOW + f"分享第{share_num}次：" + Fore.RED + f"请求错误: {e}" + Style.RESET_ALL)
    time.sleep(1)

def main():
    url66666 = "http://tool.pfan.cn/shorturl/restore"
    yul = input("输入作品链接：")
    yul = ''.join(re.findall(r"https://v.kuaishou.com/(.*? )", yul))
    if yul == "https://v.kuaishou.com/":
        print("输入的链接有误")
        print("提示:链接需要带文案")
        exit()
    print("链接为", yul)
    encoded_text = quote(yul)
    payload66666 = f"shorturl={encoded_text}"
    headers66666 = {
        "User-Agent": "Apache-HttpClient/UNAVAILABLE (java 1.4)",
        "Connection": "Keep-Alive",
        "Accept-Encoding": "identity",
        "Content-Type": "application/x-www-form-urlencoded"
    }
    response66666 = requests.post(url66666, data=payload66666, headers=headers66666)
    a1 = response66666.text
    a111 = ''.join(re.findall(r"&photoId=(.*?)&", a1))
    a222 = ''.join(re.findall(r"&userId=(.*?)&", a1))
    print("作者ID：", a111)
    print("作品ID：", a222)
    share_url = "https://www.kuaishou.com/rest/zt/share/w/any"
    headers = {
        "User-Agent": "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/91.0.4472.124 Safari/537.36",
        "Connection": "keep-alive",
        "Content-Type": "application/json",
        "Origin": "https://www.kuaishou.com",
        "Referer": "https://www.kuaishou.com",
        "Accept": "*/*",
        "Accept-Encoding": "gzip, deflate, br",
        "Accept-Language": "zh-CN,zh;q=0.9,en-US;q=0.8,en;q=0.7"
    }
    data = {
        "kpn": "KUAISHOU_VISION",
        "kpf": "PC_WEB",
        "subBiz": "SINGLE_ROW_WEB",
        "sdkVersion": "1.1.2.2.0",
        "shareChannel": "WECHAT",
        "shareMethod": "PICTURE",
        "shareObjectId": a111,
        "extTokenStoreParams": {
            "photoId": a111,
            "videoType": "short-video"
        },
        "photoAuthorId": a222
    }
    share_count = int(input("请输入需要分享的次数："))
    thread_count = int(input("请输入自定义线程数："))
    processes = []
    for i in range(1, share_count + 1):
        p = Process(target=share_worker, args=(share_url, headers, data, i))
        processes.append(p)
        p.start()
        if len(processes) >= thread_count:
            for p in processes:
                p.join()
            processes = []
    for p in processes:
        p.join()

if __name__ == "__main__":
    main()
